/****************************************************************************

  $Source: /home/foda/fracas/RCS/initers.c $
  $Revision: 7.2 $
  $Date: 1996/01/18 13:01:42 $
  $State: Exp $
  $Locker:  $

****************************************************************************/
#ident "$Id: initers.c 7.2 1996/01/18 13:01:42 pot Exp $"

/*
 *  FRACAS stands for FRAmed Channel Access Simulator.
 */

#include "fracas.h"

static initer_r even_reader;
static initer_r zero_reader;

initer_n initers [] =
{
  { even_reader, "even" },
  { zero_reader, "zero" },
  { NULL }
};

/*
 * Even initer.
 * Evenly divides the available datagram space among all the stations.
 *
 * Syntax is: initer even
 */
static void
even_initer (station *stp)
{
  int j, sum_s_v;

  sum_s_v = 0;
  for (j = 1; j <= stno; j++)
    sum_s_v += st_table[j].sreq + st_table[j].vminreq;
  for (j = 0; j < cyclelen; j++)
    {
      stp->first_f[j].allocation.s = stp->sreq;
      stp->first_f[j].allocation.v = stp->vminreq;
      stp->first_f[j].allocation.i = (framesize - sum_s_v) / stno;
      stp->first_f[j].allocation.b = 0;
    }
} /* even_initer() */

static initer *
even_reader (char *lp)
{
  return (&even_initer);
} /* even_reader() */




/*
 * Zero initer.
 * Gives no datagram allocation to all the stations.
 *
 * Syntax is: initer zero
 */
static void
zero_initer (station *stp)
{
  int j;

  for (j = 0; j < cyclelen; j++)
    {
      stp->first_f[j].allocation.s = stp->sreq;
      stp->first_f[j].allocation.v = stp->vminreq;
      stp->first_f[j].allocation.i = 0;
      stp->first_f[j].allocation.b = 0;
    }
} /* zero_initer() */

static initer *
zero_reader (char *lp)
{
  return (&zero_initer);
} /* zero_reader() */
