/*
 *  Structure definitions and function declarations
 *  for the libnr library, taken from Numerical Recipes in C
 */

#ifdef __STDC__

extern int ones (int n);
extern int comb (int n, int m);
extern double fcomb (int n, int m);
extern double secant (double f(double x), double zero, double x1, double x2);
extern float gasdev (int randgen (void));
extern float *RMDtraffic (double M, double a, double H, double T,
			  int n, float *tracep);
extern double erfcc (double x);
extern float nrselect (unsigned long k, unsigned long n, float arr[]);
extern void categorise (float q[], int samples, float min, float max,
			int catn, float cs[]);
extern void ttydistrib (float q[], int samples,
			float min, float max, float avg, float sigma,
			int rows, int cols, char *screen[]);
extern void ttygraph(float cs[], int rows, int cols, char *screen[], int fill);

#else

extern int ones ();
extern int comb ();
extern double fcomb ();
extern double secant ();
extern float gasdev ();
extern float *RMDtraffic ();
extern double erfcc ();
extern float quantile ();
extern void categorise ();
extern void ttydistrib ();
extern void ttygraph ();
#endif

/*
 * The following macros are used to make function definitions with
 * one, two or three arguments independent of whether an ANSI compiler
 * is used or not.
 */
#ifdef __STDC__
# define ARG1(arg1) (arg1)
# define ARG2(arg1, arg2) (arg1, arg2)
#else
# define ARG1(arg1) () arg1;
# define ARG2(arg1, arg2) () arg1; arg2;
#endif
