/*
 *  Structure definitions and function declarations
 *  for the stcollect package.
 */

typedef struct st_data
{
  double samples;
  double min, max;
  double sum, sumsqr;
} st_data;

#ifdef __STDC__

extern st_data *st_init (st_data *);
extern void st_collect (st_data *, double x, int n);
extern void st_add (st_data *accumulator, st_data *addendum);
extern double st_n (st_data *);
extern double st_min (st_data *);
extern double st_max (st_data *);
extern double st_avg (st_data *);
extern double st_var (st_data *);
extern double st_stddev (st_data *);

#else

extern st_data *st_init ();
extern void st_collect ();
extern void st_add ();
extern double st_n ();
extern double st_min ();
extern double st_max ();
extern double st_avg ();
extern double st_var ();
extern double st_stddev ();

#endif

/*
 * The following macros are used to make function definitions
 * independent of whether an ANSI compiler is used or not.
 */
#ifdef __STDC__
# define ARG1(arg1) (arg1)
# define ARG2(arg1, arg2) (arg1, arg2)
# define ARG3(arg1, arg2, arg3) (arg1, arg2, arg3)
#else
# define ARG1(arg1) () arg1;
# define ARG2(arg1, arg2) () arg1; arg2;
# define ARG3(arg1, arg2, arg3) () arg1; arg2; arg3;
#endif
